# Kakao Login Cookie Manual
이 문서에서는 새로운 카카오 계정 연동법에 대해 알아봅니다.
- 카카오톡으로 사용자 쿠키 파싱하기
- 파싱한 쿠키를 프로그램에 입력하기

8월 20일 카카오 API 업데이트로 인하여, 크롬 브라우저에서 로그인하는 예전의 방식은 더이상 호환되지 않습니다.

## 📌 중요한 확인 사항
- **카카오톡 잔여 백신 서비스에서 아무 병원이나 최소 1회 알림 신청을 한 적이 있어야 합니다.**
- 병원 알림 신청 시 뜨는 정보 제공 동의 약관에 동의해야 합니다.

## 📌 카카오톡으로 사용자 쿠키 파싱하기
### A. 안드로이드
<details>
  <summary>튜토리얼 보기</summary>
  <br/>
  
  **1. 다음의 링크를 복사하여 카카오톡의 나와의 채팅방에 보내놓습니다.**
  ```
  https://accounts.kakao.com/login?continue=https%3A%2F%2Fvaccine-map.kakao.com%2Fapi%2Fv1%2Fuser
  ```
  **2. 다음의 스크립트를 복사하여 카카오톡의 나와의 채팅방에 보내놓습니다.**
  ```
  javascript:document.write(document.cookie.split('_kavacto=')%5B1%5D.split(';')%5B0%5D)
  ```
  <div align="center"><img src="https://user-images.githubusercontent.com/77003554/130264973-8262def1-8e59-4066-b2e2-f9398700fff0.jpg" width="500"></div>
  
  **3. 카카오톡을 실행하여 나와의 채팅방으로 들어갑니다.**
  - 채팅방에 올라온 스크립트를 복사합니다.
  <br/>
  
  **4. 채팅방에 올라온 링크를 클릭하여 카카오 계정으로 로그인합니다.**
  <div align="center"><img src="https://user-images.githubusercontent.com/77003554/130266043-49f4b85c-508c-4bd4-9104-d4822816cb75.png" width="1000"></div>
  
  - `{"user":{"name":"이름","status": ...` 이 뜨면 5번으로 넘어갑니다.
  - `error`가 뜨면 하단의 다른 링크로 다시 로그인 해봅니다.
  ```
  https://accounts.kakao.com/login?continue=https%3A%2F%2Fvaccine.kakao.com%2Fapi%2Fv1%2Fuser
  ```
  <br/>
  
  **5. 주소창에 복사해둔 스크립트를 입력하고 엔터를 누릅니다.**
  <div align="center"><img src="https://user-images.githubusercontent.com/77003554/130266562-b099f716-dc3c-4072-99c5-a7d94d7c63fb.png" width="1000"></div>
  <br/>
  
  **6. 파싱된 쿠키 값을 복사하여 PC에서 쓸 수 있도록 해둡니다.**
  <div align="center"><img src="https://user-images.githubusercontent.com/77003554/130266256-81361cf5-e32f-48ef-881c-6683abf3e718.png" width="1000"></div>
  
  - `VGhpcyByBhIHJhbmRv...bSBiYXNgc3RyaW5nLg==` 같은 형식의 쿠키 값이 파싱되어 나옵니다.
  - 나와의 채팅방에 보내놓으면 PC 카톡에서 복사하여 쓸 수 있습니다.
</details>

### B. iOS
<details>
  <summary>튜토리얼 보기</summary>
  <br/>
  
  iOS는 두 가지 방법이 있으며, 각자 장단점이 있으니 참고하여 둘 중 하나를 선택하시기 바랍니다.
  
  ### 🏷️ 방법 1. 앱 플레이어로 안드로이드처럼 파싱하기
  ```
  [장점]
  - 방법 2보다 쉬움.
  [단점]
  - 카카오톡 계정을 앱 플레이어로 이전해야 하므로 필요 시 채팅을 백업해야 함.
  - 카카오톡 이용자 보호조치에 걸릴 수도 있음.
  ```
  
  **1. 앱 플레이어를 설치합니다.**
  - LD 플레이어, 블루스택, Nox 등
  <br/>
  
  **2. 앱 플레이어에 카카오톡을 설치한 뒤, 백신을 예약할 사용자의 카카오 계정으로 로그인합니다.**
  - 앱 플레이어의 카카오톡으로 계정을 연동하면 휴대폰 카카오톡은 자동으로 로그아웃됩니다.
  - 로그아웃 시 채팅 기록이 날라가니 필요하다면 미리 백업하셔야 합니다.
  <br/>
  
  **3. 상단의 `A. 안드로이드` 방법을 그대로 따라합니다.**
  <br/><br/>
  
  ### 🏷️ 방법 2. MITM Proxy 로 쿠키 값 찾기
  ```
  [장점]
  - 방법 1의 단점이 없음.
  [단점]
  - 맥이 필요함.
  - 초보자가 따라하기에는 다소 어려울 수 있음.
  ```
  #### 기본 세팅법
  1. 맥과 아이폰을 같은 네트워크에 연결합니다.
  2. `mitmproxy`를 설치합니다. https://mitmproxy.org
  3. 터미널에서 `mitmweb --ssl-insecure` 커맨드를 실행합니다.
  4. 브라우저가 열리면 컴퓨터의 IP주소를 확인합니다. `옵션 키`를 누른 상태로 `Wifi 목록`을 누르거나, `설정 > 네트워크`에서 확인할 수 있습니다.
  5. 아이폰의 `설정 > Wi-Fi > i 아이콘(연결한 네트워크 옆) > 프록시 설정`에 들어가서 `수동`으로 설정을 바꾼 뒤, `서버`에 컴퓨터의 IP주소를, `포트`에 8080을 입력합니다.
  6. `저장`을 눌러서 설정을 저장합니다.
  7. http://mitm.it 에서 iOS를 찾고, `Get mitmproxy-ca-cert.pem` 버튼을 누릅니다.
  8. 다시 설정 앱으로 들어갑니다.
  9. `새로운 프로파일 다운로드됨` 버튼을 눌러 프로파일을 설치합니다.
  10. `설정 > General > About > 인증서 신뢰 설정`에 들어가서 `mitmproxy`를 켭니다.
  
  #### 쿠키 값 찾기
  1. 나와의 채팅방에 다음의 링크를 올려둡니다.
  ```
  https://vaccine-map.kakao.com/map2?v=1
  ```
  2. 카카오톡을 실행하여 나와의 채팅방으로 들어가 올려둔 링크를 클릭합니다.
  3. 백신 지도가 뜨면 아무 병원 한 곳을 클릭합니다.
  4. 맥에서 `기본 세팅법` 3번에서 열린 브라우저로 들어갑니다. 모르고 브라우저를 닫았다면 http://127.0.0.1:8081 을 브라우저로 접속한 뒤 `쿠키 값 찾기` 1번부터 다시 합니다.
  5. 브라우저에서 스크롤하며 찾다보면 `https://vaccine-map.kakao.com/detail/`로 시작하는 기록이 있습니다. 클릭하면 우측에 해당 사이트의 기록이 뜹니다.
  6. `Cookie` 부분을 찾다보면 `_kavacto=`로 시작하는 것이 있습니다. `_kavacto=`를 제외한 부분을 복사해둡니다.
</details>

## 📌 파싱한 쿠키를 프로그램에 입력하기
- 프로그램을 실행하여 다음의 메시지가 나오면 복사해둔 쿠키 값을 입력합니다.
```
카카오톡 인앱 브라우저에서 확인한 쿠키 값을 입력해주세요.
예) VGhpcyBpcy...lNjQgc3RyaW5nLg== : 
```
- 입력한 쿠키 값은 `cookie.ini`에 저장되며, `exe`와 같은 경로에 놓이게 됩니다.
- 한 번 입력한 쿠키는 다음 실행 시 재사용할 수 있습니다.
```
기존의 사용자 정보로 진행하시겠습니까? Y/N : y
```
- 프로그램 상에서 기존의 쿠키를 지우고 다른 쿠키 값으로 변경할 수도 있습니다.
```
기존의 사용자 정보로 진행하시겠습니까? Y/N : n
기존에 설정된 사용자 정보가 삭제되었습니다.
카카오톡 인앱 브라우저에서 확인한 쿠키 값을 입력해주세요.
예) VGhpcyBpcy...lNjQgc3RyaW5nLg== :
```

## 📌 주의 사항
쿠키 값은 링크에서 로그인한 계정과 **무관**하며, **카카오톡 앱에 연결된 계정**을 따릅니다.
- 예) A의 계정이 연동된 카카오톡에서 링크를 클릭하여 B의 계정을 로그인해도, 쿠키 값은 A 계정 용으로 나옵니다.
- 타인의 예약을 대신 해주려는 경우. 튜토리얼을 실행하는 카카오톡 앱이 우선 타인의 계정으로 연동되어있어야 합니다.
